#include "descriptor/descriptor.h"

int main(void) 
{
	ITEM scene;
	ITEM tavoloinf,	tavolosup; 
	ITEM gamba, gamba2, gamba3, gamba4;
	ITEM bicchiere, coperchio, piatto;
	ITEM limone, pesca, pesca2, noce;
	ITEM mela, mela2, mela3, mela4;
	ITEM muro, muro2, muro3, muro4;
	ITEM soffitto, pavimento;

       	ITEM legno, frutto, metallo, ceramica, muro_attr;	

	
	set_background(0,0,0,TRUE);
	set_ambient_light(1,1,1,0.1);
	create_distant_light(-0.1,-0.2,0.1,1,1,1,10,"luce_distante");
	create_point_light(-0.999,0.5,0.5,1,1,1,3.0,50, "luce_punto");
	
	/* ATTRIBUTI */
	legno = create_attribute("legno");
        set_color(legno,0.603,0.411,0.317,0.5,0.5);
	set_reflectivity(legno,0.002,1);

	ceramica = create_attribute("ceramica");
        set_color(ceramica,0.8,0.8,0.8,0.5,0.5);
        set_reflectivity(ceramica,0.070,2);

	metallo = create_attribute("metallo");
        set_color(metallo,0.382,0.382,0.350,0.5,0.5);
        set_reflectivity(metallo,0.340,2);

	frutto = create_attribute("frutto");
	set_reflectivity(frutto,0,1);
	set_color(frutto,0.411,0.545,0.411,0.5,0.5);

	muro_attr = create_attribute("mattoni");
        set_color(muro_attr,0,0,0,0.270,0.270);
        set_reflectivity(muro_attr,0,2);
	/* FINE ATTRIBUTI */	
	
	tavolosup = read_nurbs("tavolosup.db");
	set_projection_texture(tavolosup,legno,"textures/wood20.hr",2,1,0.3,0.4);

	tavoloinf = read_nurbs("tavoloinf.db");
	set_domain_texture(tavoloinf,legno,"textures/wood20.hr",0,1,1,0,TRUE,0.8,0.9);	
	
	gamba     = read_nurbs("gamba.db");
	set_domain_texture(gamba,legno,"textures/wood20.hr",0,1,1,0,TRUE,0.8,0.9);	
	
	gamba2    = read_nurbs("gamba2.db");
	set_domain_texture(gamba2,legno,"textures/wood20.hr",0,1,1,0,TRUE,0.8,0.9);	
	
	gamba3    = read_nurbs("gamba3.db");
	set_domain_texture(gamba3,legno,"textures/wood20.hr",0,1,1,0,TRUE,0.8,0.9);	
	
	gamba4    = read_nurbs("gamba4.db");
	set_domain_texture(gamba4,legno,"textures/wood20.hr",0,1,1,0,TRUE,0.8,0.9);	
	
	bicchiere = read_nurbs("bicchiere.db");
	set_attribute(bicchiere, metallo);
	
	coperchio   = read_nurbs("coperchio.db");
	set_attribute(coperchio, metallo);
	
	piatto    = read_nurbs("piatto.db");	
	set_attribute(piatto, ceramica);
	
	limone    = read_nurbs("limone.db");
	set_domain_texture(limone,frutto,"textures/limone.hr",0,1,1,0,FALSE,0.3,0.4);	

	pesca     = read_nurbs("pesca.db");	
	set_domain_texture(pesca,frutto,"textures/lime.hr",0,1,1,0,FALSE,0.3,0.4);	

	pesca2    = read_nurbs("pesca2.db");	
	set_domain_texture(pesca2,frutto,"textures/lime.hr",0,1,1,0,FALSE,0.3,0.4);	

	noce      = read_nurbs("noce.db");	
	set_domain_texture(noce, frutto,"textures/limone.hr",0,1,1,0,FALSE,0.4,0.6);	
	
	mela      = read_nurbs("mela.db");	
	set_domain_texture(mela,frutto,"textures/mela.hr",0,1,1,0,FALSE,0.4,0.6);	
	mela2     = read_nurbs("mela2.db");	
	set_domain_texture(mela2,frutto,"textures/mela.hr",0,1,1,0,FALSE,0.4,0.6);	
	mela3     = read_nurbs("mela3.db");	
	set_domain_texture(mela3,frutto,"textures/mela.hr",0,1,1,0,FALSE,0.4,0.6);	
	mela4     = read_nurbs("mela4.db");	
	set_domain_texture(mela4,frutto,"textures/mela.hr",0,1,1,0,FALSE,0.4,0.6);	

	muro      = read_nurbs("muro1.db");	
	set_projection_texture(muro, muro_attr,"textures/muro.hr",1,1,0.2,0.2);
	muro2     = read_nurbs("muro2.db");	
	set_projection_texture(muro2, muro_attr,"textures/muro.hr",1,1,0.2,0.2);
	muro3     = read_nurbs("muro3.db");
	set_projection_texture(muro3, muro_attr,"textures/muro.hr",0,1,0.2,0.2);
	muro4     = read_nurbs("muro4.db");	
	set_projection_texture(muro4, muro_attr,"textures/muro.hr",0,1,0.2,0.2);
	soffitto  = read_nurbs("soffitto.db");
	set_projection_texture(soffitto, muro_attr,"textures/murogrezzo.hr",2,1,0.2,0.2);
	
	pavimento = read_nurbs("pavimento.db");	
	set_projection_texture(pavimento, muro_attr,"textures/murogrezzo.hr",2,1,0.2,0.2);


	scene = create_list(tavoloinf, "scene");	
	scene = insert_in_list(scene , tavolosup);
	scene = insert_in_list(scene , gamba);
	scene = insert_in_list(scene , gamba2);
	scene = insert_in_list(scene , gamba3);
	scene = insert_in_list(scene , gamba4);
	
	scene = insert_in_list(scene, bicchiere);	
	scene = insert_in_list(scene, coperchio);
	scene = insert_in_list(scene, piatto);	
	
	scene = insert_in_list(scene , muro);
	scene = insert_in_list(scene , muro2);
	scene = insert_in_list(scene , muro3);
	scene = insert_in_list(scene , muro4);
	scene = insert_in_list(scene , pavimento);
	scene = insert_in_list(scene , soffitto);

	scene = insert_in_list(scene , pesca);
	scene = insert_in_list(scene , pesca2);
	scene = insert_in_list(scene , noce);
	scene = insert_in_list(scene , limone);
	scene = insert_in_list(scene , mela);
	scene = insert_in_list(scene , mela2);
	scene = insert_in_list(scene , mela3);
	scene = insert_in_list(scene , mela4);
	


	save_scene("cezanne1.md", "scene_cezanne", scene );



	return(0);
}
